// nvtm.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "nvtm.h"
#define MAX_LOADSTRING 100

INT __cdecl dprintf(LPCTSTR pcszFormat, ...);

// Global Variables:
HINSTANCE ghInst;								// current instance
HWND ghWnd;
TCHAR gszTitle[MAX_LOADSTRING];					// The title bar text
TCHAR gszWindowClass[MAX_LOADSTRING];			// the main window class name
NOTIFYICONDATA gShellIcon = {0};
HBITMAP ghBMPDigits;

//BYTE BMPIcon[sizeof(BITMAPINFOHEADER) + (sizeof(DWORD) * 16) + 128];
//PBITMAPINFO gpBMPIcon = (PBITMAPINFO) &BMPIcon[0];
//PBITMAPINFO gpBMPDigits = NULL;

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, gszTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_NVTM, gszWindowClass, MAX_LOADSTRING);

	ghWnd = FindWindow(gszWindowClass, gszTitle);

	if (ghWnd)
		ExitProcess(0);

	RegisterWndClass(hInstance);

	// Perform application initialization:
	if (!InitInstance(hInstance, SW_SHOWMINNOACTIVE)) 
	{
		return FALSE;
	}
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		//TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM RegisterWndClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_NVTM);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_NVTM;
	wcex.lpszClassName	= gszWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   if (!NvInitApi())
	   return FALSE;

   ghInst = hInstance; // Store instance handle in our global variable

   ghWnd = CreateWindow(gszWindowClass, gszTitle, WS_POPUPWINDOW, 0, 0, 0, 0, NULL, NULL, hInstance, NULL);

   if (!ghWnd)
   {
      return FALSE;
   }

   ShowWindow(ghWnd, nCmdShow);
   UpdateWindow(ghWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	//int wmId, wmEvent;
	dprintf((LPCTSTR) "MSG 0x%08x: lParam = 0x%08x, wParam = 0x%08x\n", uiMsg, lParam, wParam);

    switch(uiMsg) 
    {
        case WM_PAINT:
            return OnPaint(hWnd, uiMsg, wParam, lParam);

        case WM_TIMER:
            return OnTimer(hWnd, uiMsg, wParam, lParam);

		case WM_SIZE:
			return OnSize(hWnd, uiMsg, wParam, lParam);

		case WM_COMMAND:
			return OnCommand(hWnd, uiMsg, wParam, lParam);

        case WM_TRAYNOTIFY:
            return OnTrayNotify(hWnd, uiMsg, wParam, lParam);

		case WM_SHOWWINDOW:
			return OnShowWindow(hWnd, uiMsg, wParam, lParam);

		//case WM_INITDIALOG:
			//return OnInitDialog(hWnd, uiMsg, wParam, lParam);

        case WM_ENDSESSION:
            return OnEndSession(hWnd, uiMsg, wParam, lParam);
        
        case WM_CLOSE:
			return OnClose(hWnd, uiMsg, wParam, lParam);

		case WM_DESTROY:
			return OnDestroy(hWnd, uiMsg, wParam, lParam);

		default:
        {
            static UINT uiTaskBarCreated = 0;

            if (!uiTaskBarCreated)
                uiTaskBarCreated = RegisterWindowMessage("TaskbarCreated");

            if (uiMsg == uiTaskBarCreated)
                Shell_NotifyIcon(NIM_ADD, &gShellIcon);
			break;
        }
    }

    return DefWindowProc(hWnd, uiMsg, wParam, lParam);
}

LRESULT OnCommand(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	/*
	switch(LOWORD(wParam))
	{
        default:
            break;

	}
	*/

	return (LRESULT) 0;
}

// WM_COMMAND msg handler
LRESULT OnSysCommand(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	/*
	switch(LOWORD(wParam))
	{
        default:
            break;

	}
	*/

	return (LRESULT) 0;
}

// WM_CLOSE msg handler
LRESULT OnClose(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	DestroyWindow(hWnd);
	return (LRESULT) 0;
}

// WM_ENDSESSION msg handler
LRESULT OnEndSession(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	return (LRESULT) 0;
}

// WM_DESTROY msg handler
LRESULT OnDestroy(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
    Shell_NotifyIcon(NIM_DELETE, &gShellIcon);
	PostQuitMessage(0);
	return (LRESULT) 0;
}

LRESULT OnSize(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
    if (wParam == SIZE_MINIMIZED)
    {
        ShowWindow(hWnd, SW_HIDE);
    }
    else if (wParam == SIZE_MAXIMIZED)
    {
        ShowWindow(hWnd, SW_SHOW);
    }
    else if (wParam == SIZE_RESTORED)
    {
        SetForegroundWindow(hWnd);
    }

 	return (LRESULT) 0;
}

LRESULT OnTrayNotify(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
    if (lParam == WM_LBUTTONDOWN || lParam == WM_RBUTTONDOWN)
    {
        //dprintf("TRAYNOTIFY: lParam = 0x%08x, wParam = 0x%08x\n", lParam, wParam);
		if (lParam == WM_RBUTTONDOWN)
			DestroyWindow(hWnd);
    }
 	return (LRESULT) 0;
}

LRESULT OnShowWindow(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
    //dprintf((LPCTSTR) "WM_SHOWWINDOW: lParam = 0x%08x, wParam = 0x%08x\n", lParam, wParam);

	if (!gShellIcon.cbSize)
	{
		gShellIcon.cbSize = NOTIFYICONDATA_V1_SIZE;
		gShellIcon.hIcon = (HICON) LoadImage(ghInst, MAKEINTRESOURCE(IDI_NVTRAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		gShellIcon.hWnd = hWnd;
		gShellIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		gShellIcon.uCallbackMessage = WM_TRAYNOTIFY;
		_tcscpy(&gShellIcon.szTip[0], "GPU Temperature");
		Shell_NotifyIcon(NIM_ADD, &gShellIcon);
		
		ghBMPDigits = LoadBitmap(ghInst, MAKEINTRESOURCE(IDB_DIGITS));
		
		/*
		gpBMPDigits = (PBITMAPINFO) LockResource(LoadResource(NULL, FindResource(NULL, MAKEINTRESOURCE(IDB_DIGITS), RT_BITMAP)));
		gpBMPIcon->bmiHeader = gpBMPDigits->bmiHeader;
		gpBMPIcon->bmiHeader.biSizeImage = 0;
		gpBMPIcon->bmiHeader.biHeight = gpBMPIcon->bmiHeader.biWidth = 16;
		memcpy(&gpBMPIcon->bmiColors, &gpBMPDigits->bmiColors, sizeof(DWORD) * 16);
		*/

		PostMessage(hWnd, WM_TIMER, 1, 0);
	}

 	return (LRESULT) 0;
}

VOID UpdateTrayStatus()
{
	static DWORD dwCore = 0, dwPrev = ~dwCore;
	DWORD dwAmbient, dwLimit;

	NvCplGetThermalSettings(0, &dwCore, &dwAmbient, &dwLimit);

	if (dwCore != dwPrev)
	{
		//dprintf("%u\n", dwCore);	
		dwPrev = dwCore;
		HDC hDC = GetDC(NULL);
		HBITMAP hBMPIcon = CreateIconBitmap(hDC, dwCore);
		HICON hIcon = gShellIcon.hIcon;
		
		gShellIcon.hIcon = CreateTrayIcon(hBMPIcon);
		Shell_NotifyIcon(NIM_MODIFY, &gShellIcon);

	    DeleteObject(hBMPIcon);
		DestroyIcon(hIcon);
		ReleaseDC(NULL, hDC);
	}
}

HBITMAP CreateIconBitmap(HDC hDC, UINT uiValue)
{
	if (uiValue > 199)
		uiValue = 199;

	HDC hDCBMP = CreateCompatibleDC(NULL);
	HDC hDCIconBMP = CreateCompatibleDC(NULL);
	HBITMAP hIconBMP = CreateCompatibleBitmap(hDC, 16, 16);
	//CreateDIBitmap(hDC, &gpBMPDigits->bmiHeader, CBM_INIT, &gpBMPDigits->bmiColors[16], gpBMPDigits, DIB_RGB_COLORS);

	SelectObject(hDCBMP, ghBMPDigits);
	SelectObject(hDCIconBMP, hIconBMP);

	if (uiValue < 100)
	{
		BitBlt(hDCIconBMP, 0, 0, 1, DIGIT_HEIGHT, NULL, 0, 0, BLACKNESS);
		BitBlt(hDCIconBMP, 1, 0, 7, DIGIT_HEIGHT, hDCBMP, uiValue / 10 * 7, 0, SRCCOPY);
		BitBlt(hDCIconBMP, 8, 0, 8, DIGIT_HEIGHT, hDCBMP, uiValue % 10 * 7, 0, SRCCOPY);
	}
	else
	{
		uiValue -= 100;
		BitBlt(hDCIconBMP, 1, 0, 7, DIGIT_HEIGHT, hDCBMP, 11, 0, SRCCOPY);
		BitBlt(hDCIconBMP, 3, 0, 7, DIGIT_HEIGHT, hDCBMP, uiValue / 10 * 7, 0, SRCCOPY);
		BitBlt(hDCIconBMP, 9, 0, 7, DIGIT_HEIGHT, hDCBMP, uiValue % 10 * 7, 0, SRCCOPY);
	}

	SelectObject(hDCBMP, GetStockObject(BLACK_BRUSH));
	SelectObject(hDCIconBMP, GetStockObject(BLACK_BRUSH));

	//BitBlt(hDC, 0, 0, 16, 16, hDCIconBMP, 0, 0, SRCCOPY);

	DeleteDC(hDCBMP);
	DeleteDC(hDCIconBMP);
	
	return hIconBMP;
}

HICON CreateTrayIcon(HBITMAP hBMPIcon)
{
	ICONINFO IconInfo = {0};
	static HBITMAP hBMPMask;

	if (!hBMPMask)
	{
		BITMAP BMPMask = {0};
		BYTE Mask[32] = {0};

		BMPMask.bmBitsPixel = 1;
		BMPMask.bmPlanes = 1;
		BMPMask.bmWidth = 16;
		BMPMask.bmHeight = 16;
		BMPMask.bmWidthBytes = 2;
		BMPMask.bmBits = Mask;

		hBMPMask = CreateBitmapIndirect(&BMPMask);

	}

	IconInfo.fIcon = TRUE;
	IconInfo.hbmColor = hBMPIcon;
	IconInfo.hbmMask = hBMPMask;
	return CreateIconIndirect(&IconInfo);
}

LRESULT OnPaint(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	/*
	PAINTSTRUCT paint;

	HDC hDC = BeginPaint(hWnd, &paint);
	EndPaint(hWnd, &paint);
	*/
    return (LRESULT) 0;
}

LRESULT OnTimer(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
    if (wParam == ~0)
    {
        UpdateTrayStatus();
    }
    else if (wParam == 1)
    {
        SetTimer(hWnd, ~0, 2000, NULL);
		SetProcessWorkingSetSize(GetCurrentProcess(), -1, -1);
    }
    return (LRESULT) 0;
}

INT __cdecl dprintf(LPCTSTR pcszFormat, ...)
{
    INT  iRC    = 0;
    va_list     vaPtr;
    TCHAR szBuf[128];

    if (pcszFormat)
    {
        va_start(vaPtr, pcszFormat);     

        iRC = _vsntprintf(szBuf, sizeof(szBuf) - sizeof(szBuf[0]), pcszFormat, vaPtr);
        if (iRC == -1)
        {
            szBuf[sizeof(szBuf) - sizeof(szBuf[0])] = '\0';
            iRC = sizeof(szBuf) - sizeof(szBuf[0]);
        }
   
        if (iRC > 0)
            OutputDebugString(szBuf);
    }
   
    return iRC;
}